/* This program is Transfer2n_1 at scattering region. Aug/16/2012 */
/*     Main and sub programs were coded by Tatsuya Usuki.         */
/*                                Last modified on Aug/26/2013    */
#include "STMM.h"
void H_wavefun(const char Yee[], const long n, const long L[8], const double fg[(L[0]+L[1])*2], const double h[L[6]*2], const long row_column[2], double complex PsiR[], const long N_ad[L[7]], const long LMuvw[L[7]])
{
// L[0]=L, L[1]=M, L[2]=B_u, L[3]=B_v, L[4]=J_b, L[5]=J_t, L[6]=N, L[7]=imag_cont
// epmu[6*L[0]*L[1]]: epmu[l + L[0]*m + 0*L[0]*L[1]] = epsi_u(l,m), epmu[l + L[0]*m + 1*L[0]*L[1]] = epsi_v(l,m), epmu[l + L[0]*m + 2*L[0]*L[1]] = 1/epsi_w(l,m),
//                    epmu[l + L[0]*m + 3*L[0]*L[1]] =   mu_u(l,m), epmu[l + L[0]*m + 4*L[0]*L[1]] =   mu_v(l,m), epmu[l + L[0]*m + 5*L[0]*L[1]] =   1/mu_w(l,m).
//					LMuvw[I_line] = l + L[0]*m + uvw*L[0]*L[1]
	long MM = 2*L[0]*L[1];
	for(long I_line = 0 ; I_line < L[7] ; I_line++) {
		if(n == N_ad[I_line]) {
			long J_row = MM + L[4] + I_line;//revised 20121121
			long index_6 = LMuvw[I_line]/(L[0]*L[1]);
			long index_LM = LMuvw[I_line]%(L[0]*L[1]);
			if(index_6 == 3 || index_6 == 4) {
				long J_column = index_LM + (index_6 - 3)*L[0]*L[1];
				PsiR[J_row + row_column[0]*J_column] = 1.;
			}
			if(index_6 == 2) {
				char Yeex[BUFSIZE];
				sprintf(Yeex,"%s%ld.dat", Yee, n);
				double complex epmu[6*L[0]*L[1]];
				read_epmu(Yeex, L, epmu);
				double complex *H_uv, *E_w;
				H_uv = malloc(sizeof(double complex)*MM);
				E_w = malloc(sizeof(double complex)*L[0]*L[1]);
				if(H_uv == NULL || E_w == NULL) exit(1);
				for(long J_column = 0 ; J_column < MM ; J_column++) {
					//double complex H_uv[MM], E_w[L[0]*L[1]];
					for(long J1 = 0 ; J1 < MM ; J1++) {
						H_uv[J1] = 0.;
					}
					H_uv[J_column] = 1.;
					cal_Ew(L, epmu, fg, H_uv, E_w);
					PsiR[J_row + row_column[0]*J_column] = E_w[index_LM];
				}
				free(H_uv);
				free(E_w);
			}
		}
	}

}
void E_wavefun(const char Yee[], const long n, const long L[8], const double fg[(L[0]+L[1])*2], const double h[L[6]*2], const long row_column[2], double complex PsiR[], const long N_ad[L[7]], const long LMuvw[L[7]])
{
// L[0]=L, L[1]=M, L[2]=B_u, L[3]=B_v, L[4]=J_b, L[5]=J_t, L[6]=N, L[7]=imag_cont
// epmu[6*L[0]*L[1]]: epmu[l + L[0]*m + 0*L[0]*L[1]] = epsi_u(l,m), epmu[l + L[0]*m + 1*L[0]*L[1]] = epsi_v(l,m), epmu[l + L[0]*m + 2*L[0]*L[1]] = 1/epsi_w(l,m),
//                    epmu[l + L[0]*m + 3*L[0]*L[1]] =   mu_u(l,m), epmu[l + L[0]*m + 4*L[0]*L[1]] =   mu_v(l,m), epmu[l + L[0]*m + 5*L[0]*L[1]] =   1/mu_w(l,m).
//					LMuvw[I_line] = l + L[0]*m + uvw*L[0]*L[1]
	long MM = 2*L[0]*L[1];
	for(long I_line = 0 ; I_line < L[7] ; I_line++) {
		if(n == N_ad[I_line]) {
			long J_row = MM + L[4] + I_line;//revised 20121121
			long index_6 = LMuvw[I_line]/(L[0]*L[1]);
			long index_LM = LMuvw[I_line]%(L[0]*L[1]);
			if(index_6 == 0) {//epsi_u E_u
				long J_column = index_LM + L[0]*L[1];
				PsiR[J_row + row_column[0]*J_column] = 1.;
			}
			if(index_6 == 1) {//epsi_v mE_v
				long J_column = index_LM;
				PsiR[J_row + row_column[0]*J_column] = -1.;
			}
			if(index_6 == 5) {
				char Yeex[BUFSIZE];
				sprintf(Yeex,"%s%ld.dat", Yee, n);
				double complex epmu[6*L[0]*L[1]];
				read_epmu(Yeex, L, epmu);
				double complex *E_vu, *H_w;
				E_vu = malloc(sizeof(double complex)*MM);
				H_w = malloc(sizeof(double complex)*L[0]*L[1]);
				if(E_vu == NULL || H_w == NULL) exit(1);
				for(long J_column = 0 ; J_column < MM ; J_column++) {
					//double complex E_vu[MM], H_w[L[0]*L[1]];
					for(long J1 = 0 ; J1 < MM ; J1++) {
						E_vu[J1] = 0.;
					}
					E_vu[J_column] = 1.;
					cal_Hw(L, epmu, fg, E_vu, H_w);
					PsiR[J_row + row_column[0]*J_column] = H_w[index_LM];
				}
				free(E_vu);
				free(H_w);
			}
		}
	}

}
