/* This program is calc. for inverse matrix. Aug/16/2012      */
/*     Main and sub programs were coded by Tatsuya Usuki.     */
/*                            It was modified in Nov/03/2014  */
#include <tgmath.h>
#include <stdio.h>
#include <stdlib.h>
void Inv_calc(const long MM, const long row_num, double complex PsiR[row_num*MM], double complex Ref_R[MM*MM])
{
	long max_line = row_num - 1;                           //revised 20120927
	for(long JL = row_num - 1 ; JL >= 0 ; JL--) {          //revised 20120927
		for(long JC = 0 ; JC < MM ; JC++) {                 //revised 20120927
			double complex Psi = PsiR[JL + row_num*JC];    //revised 20120927
			if(fabs(creal(Psi))+fabs(cimag(Psi)) > 1.e-16) {//revised 20120927
				max_line = JL;                              //revised 20120927
				goto OUT_JL;                                //revised 20120927
			}                                               //revised 20120927
		}                                                   //revised 20120927
	}                                                       //revised 20120927
	OUT_JL:;                                                //revised 20120927

	for(long JC = MM - 1 ; JC >= 0 ; JC--) {
		if(fabs(Ref_R[JC + MM*JC]) < 5.E-16 || 1./fabs(Ref_R[JC + MM*JC]) < 5.E-16){
			fprintf(stderr,"Ref_R error at Inv_calc!: column step= %ld, Ref_R= %.5E\n", 
					JC, fabs(Ref_R[JC + MM*JC]));//20141103 revised;
			exit(1);
		}
		double complex a = 1./Ref_R[JC + MM*JC];
		for(long JL = JC - 1 ; JL >= 0 ; JL--) {
			Ref_R[JL + MM*JC] *= a;
		}
		for(long JL = 0 ; JL <= max_line ; JL++) {
			PsiR[JL + row_num*JC] *= a;
		}
		for(long JCC = JC - 1 ; JCC >= 0 ; JCC--) {
			double complex b = Ref_R[JC + MM*JCC];
			for(long JL = JC - 1 ; JL >= 0 ; JL--) {
				Ref_R[JL + MM*JCC] -= b*Ref_R[JL + MM*JC];
			}
			for(long JL = 0 ; JL <= max_line ; JL++) {           //revised 20120927
				double complex Psi = PsiR[JL + row_num*JC];     //revised 20120914
				if(fabs(creal(Psi))+fabs(cimag(Psi)) > 1.e-16) { //revised 20120914
					PsiR[JL + row_num*JCC] -= b*Psi;            //revised 20120914
				}                                                //revised 20120914
//				PsiR[JL + row_num*JCC] -= b*PsiR[JL + row_num*JC];
			}
		}
	}
	for(long JC = 0 ; JC < MM ; JC++) {
		for(long JCC = JC + 1 ; JCC < MM ; JCC++) {
			double complex b = Ref_R[JC + MM*JCC];
			for(long JL = 0 ; JL <= max_line ; JL++) {//revised 20120927
				PsiR[JL + row_num*JCC] -= b*PsiR[JL + row_num*JC];
			}
		}
	}
}
void RtoL(const long MM, const long row_column[2], double complex PsiL[], double complex PsiR[], double complex Ref_L[MM*row_column[1]])
{
	long max_line = row_column[0] - 1;                       //revised 20120927
	for(long JL = row_column[0] - 1 ; JL >= 0 ; JL--) {      //revised 20120927
		for(long JC = 0 ; JC < MM ; JC++) {                   //revised 20120927
			double complex Psi = PsiR[JL + row_column[0]*JC];//revised 20120927
			if(fabs(creal(Psi))+fabs(cimag(Psi)) > 1.e-16) {  //revised 20120927
				max_line = JL;                                //revised 20120927
				goto OUT_JL;                                  //revised 20120927
			}                                                 //revised 20120927
		}                                                     //revised 20120927
	}                                                         //revised 20120927
	OUT_JL:;                                                  //revised 20120927
	for(long JC =0 ; JC < row_column[1] ; JC++) {
		for(long JL = 0 ; JL <= max_line ; JL++) {//revised 20120927
			for(long K = 0 ; K < MM ; K++) {
				PsiL[JL + row_column[0]*JC] -= PsiR[JL + row_column[0]*K]*Ref_L[K + MM*JC];
			}
		}
	}
}
