/*     This program is Transfer0 at Bottom. Aug/15/2012       */
/*     Main and sub programs were coded by Tatsuya Usuki.     */
/*                            Last modified on Nov/03/2014    */
#include "STMM.h"
void Transfer0(const char Yee[], const long L[8], const double fg[(L[0]+L[1])*2], const double h[L[6]*2], const long row_column[2], double complex PsiL[], double complex PsiR[])
{
// L[0]=L, L[1]=M, L[2]=B_u, L[3]=B_v, L[4]=J_b, L[5]=J_t, L[6]=N.
	char Yeex[BUFSIZE];
	sprintf(Yeex,"%sBottom.dat", Yee);

	long MM = 2*L[0]*L[1];
	//double complex theta[MM], Ub[MM*MM];
	double complex *theta, *Ub;
	theta = malloc(sizeof(double complex)*MM);
	Ub = malloc(sizeof(double complex)*MM*MM);
	if(theta == NULL || Ub == NULL) exit(1);
	{
		read_tU(Yeex, MM, theta, Ub);
	}


	
//	row_column[0]: row number of PsiL and PsiR, row_column[1]: column number of PsiL;
	for(long J_column = 0 ; J_column < L[4] ; J_column++) {// J_column (>= L[4]) used from step 2N-2. 
		for(long J_row = 0 ; J_row < MM ; J_row++) {//C_1,00
			PsiL[J_row + row_column[0]*J_column] = Ub[J_row + MM*J_column]*(1.0 + theta[J_column]);// Eq.(26) in "Wageguide_Simulation_v4.pdf"
		}
		for(long J_row = MM ; J_row < MM + L[4] ; J_row++) {//D_1,00
			PsiL[J_row + row_column[0]*J_column] = 0.;
			if(J_row - MM == J_column) PsiL[J_row + row_column[0]*J_column] = theta[J_column];// Eqs.(24) and (25) in "Wageguide_Simulation_v4.pdf"
		}
		for(long J_row = MM + L[4] ; J_row < row_column[0] ; J_row++) {
			PsiL[J_row + row_column[0]*J_column] = 0.;
		}
	}
	double complex hhi = -h[0]*h[0]*I;// Eq.(26) in "Wageguide_Simulation_v4.pdf"
	for(long J_column = 0 ; J_column < MM ; J_column++) {
		for(long J_row = 0 ; J_row < MM ; J_row++) {//C_1,01
			PsiR[J_row + row_column[0]*J_column] = hhi*(1.0 - theta[J_row])*Ub[J_column + MM*J_row];// (1 - Theta)*Ub^T in Eq. (26)
		}
		for(long J_row = MM ; J_row < MM + L[4] ; J_row++) {//D_1,01
			PsiR[J_row + row_column[0]*J_column] = PsiR[J_row - MM + row_column[0]*J_column];
		}
		multiplyMat(MM, Ub, PsiR, row_column[0]*J_column);//C_1,01
		
		for(long J_row = MM + L[4] ; J_row < row_column[0] ; J_row++) {
			PsiR[J_row + row_column[0]*J_column] = 0.;
		}
	}
	free(theta);
	free(Ub);
}
void multiplyMat(const long MM, const double complex Ub[MM*MM], double complex A[MM], const long shift_line)
{
	//double complex B[MM];
	double complex *B;
	B = malloc(sizeof(double complex)*MM);
	if(B == NULL) exit(1);
	for(long J1 = 0 ; J1 < MM ; J1++) {
		B[J1] = 0.;
		for(long J2 = 0 ; J2 < MM ; J2++) {
			B[J1] += Ub[J1+MM*J2]*A[J2+ shift_line];
		}
	}
	for(long J1 = 0 ; J1 < MM ; J1++) {
		A[J1 + shift_line] = B[J1];
	}
}
void read_tU(char Yeex[], const long MM, double complex theta[MM], double complex Ub[MM*MM])
{
	char buf[BUFSIZE];
	FILE *fp_i;
	fp_i = fopen(Yeex,"r");
//	double complex Beta[MM];
/*	for(long J_column = 0 ; J_column < MM ; J_column++) {
		if(fgets(buf, sizeof buf, fp_i) == NULL){
			fprintf(stderr,"fgets error!: E(%ld)\n", J_column);
			exit(1);
		}
		long K;
		double r_Lsqr, i_Lsqr, r_Beta, i_Beta;
		if(sscanf(buf,"%ld %lf %lf %lf %lf", &K, &r_Lsqr, &i_Lsqr, &r_Beta, &i_Beta) != 5){
			fprintf(stderr,"input error at read_tU for bottom!: line=%ld\n",  K);
			exit(1);
		}
		if(K != J_column){
			fprintf(stderr,"input error at read_tU for bottom!: J_column= %ld, K= %ld\n", J_column, K);
			exit(1);
		}
		theta[J_column] = exp(I*r_Beta - i_Beta);
	}*/
//20141102
	{
		long J_column = 0;
		while(fgets(buf, sizeof( buf ), fp_i) != NULL) {
			long K;
			double r_Lsqr, i_Lsqr, r_Beta, i_Beta;
			if(sscanf(buf,"%ld %lf %lf %lf %lf", &K, &r_Lsqr, &i_Lsqr, &r_Beta, &i_Beta) == 5){
				if(K == J_column) {
					theta[J_column] = exp(I*r_Beta - i_Beta);
					J_column++;
				}
				if(J_column == MM) goto End_of_eigenvalue;
			}
		}
		fprintf(stderr,"The %ld-th eigenvalue was not read @ %s in read_tU for bottom!\n",J_column, Yeex);
		exit(1);
		End_of_eigenvalue:;
	}
//20141102end
/*	for(long J_column = 0 ; J_column < MM ; J_column++) {
		for(long J_row = 0 ; J_row < MM ; J_row++) {
			if(fgets(buf, sizeof buf, fp_i) == NULL){
				fprintf(stderr,"fgets error!: %ld, %ld\n", J_row, J_column);
				exit(1);
			}
			double r_U, i_U;
			if(sscanf(buf,"%lf %lf", &r_U, &i_U) != 2){
				fprintf(stderr,"input error!: %ld, %ld\n", J_row, J_column);
				exit(1);
			}
			Ub[J_row + J_column*MM] = r_U + I*i_U;
		}
	}*/
//20141103
	{
		long J_column = 0;
		while(fgets(buf, sizeof( buf ), fp_i) != NULL) {
			long J_check, K_check;
			if(sscanf(buf,"%*[^(] %*[(] %ld %*[^(] %*[(] %ld", &J_check, &K_check) == 2){
				if(J_check == J_column && J_check == K_check) {
					long J_row = 0;
					while(fgets(buf, sizeof( buf ), fp_i) != NULL) {
						double r_U, i_U;
						if(sscanf(buf,"%lf %lf", &r_U, &i_U) == 2){
							Ub[J_row + J_column*MM] = r_U + I*i_U;
							J_row++;
						}
						if(J_row == MM) goto End_of_columnvector;
					}
					fprintf(stderr,"The %ld-th element of %ld column in read_tU of Tansfer0.c was not read @ %s!\n", 
							J_row, J_column, Yeex);
					exit(1);
					End_of_columnvector:;
					J_column++;
				}
				if(J_column == MM) goto End_of_eigenvector;
			}
		}
		fprintf(stderr,"The %ld-th eigenvector in read_tU of Tansfer0.c was not read @ %s!\n",J_column, Yeex);
		exit(1);
		End_of_eigenvector:;
	}
//20141103end
	fclose(fp_i);
}
