/* This program is Transfer2n_1 at scattering region. Aug/16/2012 */
/*     Main and sub programs were coded by Tatsuya Usuki.         */
/*                                Last modified on Nov/02/2014    */
#include "STMM.h"
void Transfer2n_1(const char Yee[], const long n, const long L[7], const double fg[(L[0]+L[1])*2], const double h[L[6]*2], const long row_column[2], double complex PsiL[], double complex PsiR[])
{
// L[0]=L, L[1]=M, L[2]=B_u, L[3]=B_v, L[4]=J_b, L[5]=J_t, L[6]=N.
	char Yeex[BUFSIZE];
	sprintf(Yeex,"%s_Med%ld.dat", Yee, n-1);
	double complex epmu[6*L[0]*L[1]];
	read_epmu(Yeex, L, epmu);
	long MM = 2*L[0]*L[1];
	//double complex Ref_L[MM*row_column[1]];//	row_column[0]: row number of PsiL and PsiR, row_column[1]: column number of PsiL;
	double complex *Ref_L;//	row_column[0]: row number of PsiL and PsiR, row_column[1]: column number of PsiL;
	Ref_L = malloc(sizeof(double complex)*MM*row_column[1]);
	if(Ref_L == NULL) exit(1);
	
	double hh00 =h[(n-1)*2 + 0]/ h[n*2 + 0];// Eq. (19) in "Wageguide_Simulation_v4.pdf"
	for(long J_column = 0 ; J_column < L[4] ; J_column++) {
		for(long J_row = 0 ; J_row < MM ; J_row++) {
			Ref_L[J_row + MM*J_column] = hh00*PsiL[J_row + row_column[0]*J_column];
			PsiL[J_row + row_column[0]*J_column] = 0.;
		}
	}
	//double complex Ref_R[MM*MM];
	double complex *Ref_R;
	Ref_R = malloc(sizeof(double complex)*MM*MM);
	if(Ref_R == NULL) exit(1);
	
	double complex *Bsub0, *Bsub1;
	Bsub0 = malloc(sizeof(double complex)*MM);
	Bsub1 = malloc(sizeof(double complex)*MM);
	if(Bsub0 == NULL || Bsub1 == NULL) exit(1);

	for(long J_column = 0 ; J_column < MM ; J_column++) {
		//double complex Bsub0[MM], Bsub1[MM];
		double complex hhi = I/(h[n*2 + 0]*h[(n-1)*2 + 1]);// Eq. (19) in "Wageguide_Simulation_v4.pdf"
		for(long J_row = 0 ; J_row < MM ; J_row++) {
			Bsub0[J_row] = 0.;
			if(J_row == J_column) Bsub0[J_row] = hhi;
		}
		M_HE(L, epmu, fg, Bsub0, 0, Bsub1, 0);//forward: (i/h_1/h_0)*M_EH
		for(long J_row = 0 ; J_row < MM ; J_row++) {
			Ref_R[J_row + MM*J_column] = hh00*PsiR[J_row + row_column[0]*J_column] + Bsub1[J_row];
			PsiR[J_row + row_column[0]*J_column] = 0.;
			if(J_row == J_column) PsiR[J_row + row_column[0]*J_column] = 1.;
		}
	}
	free(Bsub0);
	free(Bsub1);
	
	Inv_calc(MM, row_column[0], PsiR, Ref_R);
	long row_column_part[2] = {row_column[0], L[4]};
	RtoL(MM, row_column_part, PsiL, PsiR, Ref_L);
	
	free(Ref_L);
	free(Ref_R);
}
void Transfer2n(const char Yee[], const long n, const long L[7], const double fg[(L[0]+L[1])*2], const double h[L[6]*2], const long row_column[2], double complex PsiL[], double complex PsiR[])
{
// L[0]=L, L[1]=M, L[2]=B_u, L[3]=B_v, L[4]=J_b, L[5]=J_t, L[6]=N.
	char Yeex[BUFSIZE];
	sprintf(Yeex,"%s_Med%ld.dat", Yee, n);
	double complex epmu[6*L[0]*L[1]];
	read_epmu(Yeex, L, epmu);
	long MM = 2*L[0]*L[1];
	//double complex Ref_L[MM*row_column[1]];//	row_column[0]: row number of PsiL and PsiR, row_column[1]: column number of PsiL;
	double complex *Ref_L;//	row_column[0]: row number of PsiL and PsiR, row_column[1]: column number of PsiL;
	Ref_L = malloc(sizeof(double complex)*MM*row_column[1]);
	if(Ref_L == NULL) exit(1);

	double hh11 =h[(n-1)*2 + 1]/ h[n*2 + 1];// Eq. (19) in "Wageguide_Simulation_v3.pdf"
	for(long J_column = 0 ; J_column < L[4] ; J_column++) {
		for(long J_row = 0 ; J_row < MM ; J_row++) {
			Ref_L[J_row + MM*J_column] = hh11*PsiL[J_row + row_column[0]*J_column];
			PsiL[J_row + row_column[0]*J_column] = 0.;
		}
	}
	//double complex Ref_R[MM*MM];
	double complex *Ref_R;
	Ref_R = malloc(sizeof(double complex)*MM*MM);
	if(Ref_R == NULL) exit(1);
	
	double complex *Bsub0, *Bsub1;
	Bsub0 = malloc(sizeof(double complex)*MM);
	Bsub1 = malloc(sizeof(double complex)*MM);
	if(Bsub0 == NULL || Bsub1 == NULL) exit(1);
	for(long J_column = 0 ; J_column < MM ; J_column++) {
		//double complex Bsub0[MM], Bsub1[MM];
		double complex hhi = I/(h[n*2 + 1]*h[n*2 + 0]);// Eq. (19) in "Wageguide_Simulation_v3.pdf"
		for(long J_row = 0 ; J_row < MM ; J_row++) {
			Bsub0[J_row] = 0.;
			if(J_row == J_column) Bsub0[J_row] = hhi;
		}
		M_EH(L, epmu, fg, Bsub0, 0, Bsub1, 0);
		for(long J_row = 0 ; J_row < MM ; J_row++) {
			Ref_R[J_row + MM*J_column] = hh11*PsiR[J_row + row_column[0]*J_column] + Bsub1[J_row];
			PsiR[J_row + row_column[0]*J_column] = 0.;
			if(J_row == J_column) PsiR[J_row + row_column[0]*J_column] = 1.;
		}
	}
	free(Bsub0);
	free(Bsub1);
	
	Inv_calc(MM, row_column[0], PsiR, Ref_R);
	long row_column_part[2] = {row_column[0], L[4]};
	RtoL(MM, row_column_part, PsiL, PsiR, Ref_L);
	
	free(Ref_L);
	free(Ref_R);
}
void read_epmu(char Yeex[], const long L[4], double complex epmu[6*L[0]*L[1]])
{
// L[4]             : L[0] = L, L[1] = M, L[2] = B_u and L[3] = B_v.
// epmu[6*L[0]*L[1]]: epmu[l + L[0]*m + 0*L[0]*L[1]] = epsi_u(l,m), epmu[l + L[0]*m + 1*L[0]*L[1]] = epsi_v(l,m), epmu[l + L[0]*m + 2*L[0]*L[1]] = 1/epsi_w(l,m),
//                    epmu[l + L[0]*m + 3*L[0]*L[1]] =   mu_u(l,m), epmu[l + L[0]*m + 4*L[0]*L[1]] =   mu_v(l,m), epmu[l + L[0]*m + 5*L[0]*L[1]] =   1/mu_w(l,m).
//
	char buf[BUFSIZE];
	FILE *fp_i;
	fp_i = fopen(Yeex,"r");
	if (fp_i == NULL){
		fprintf(stderr,"Do not open data file @ read_epmu!\n");
		exit(1);
	}
	long J_sum = 0;
	while(fgets(buf, sizeof( buf ), fp_i) != NULL) { 
		long NU, NV, SubN;
		double r_mu, i_mu, r_mv, i_mv, r_ew, i_ew;
		if(sscanf(buf,"%ld %ld %ld %lf %lf %lf %lf %lf %lf", 
			&NU, &NV, &SubN, &r_mu, &i_mu, &r_mv, &i_mv, &r_ew, &i_ew) == 9){
			if(NU == J_sum%L[0] && NV == (J_sum/L[0]) && SubN == 0){
				while(fgets(buf, sizeof( buf ), fp_i) != NULL) { 
					double r_eu, i_eu, r_ev, i_ev, r_mw, i_mw;
					if(sscanf(buf,"%ld %ld %ld %lf %lf %lf %lf %lf %lf",
						 &NU, &NV, &SubN, &r_ev, &i_ev, &r_eu, &i_eu, &r_mw, &i_mw) == 9){
						if(NU == J_sum%L[0] && NV == (J_sum/L[0]) && SubN == 1) {
							epmu[J_sum + 0*L[0]*L[1]] = r_eu + I*i_eu;
							epmu[J_sum + 1*L[0]*L[1]] = r_ev + I*i_ev;
							epmu[J_sum + 2*L[0]*L[1]] = 1./(r_ew + I*i_ew);
							epmu[J_sum + 3*L[0]*L[1]] = r_mu + I*i_mu;
							epmu[J_sum + 4*L[0]*L[1]] = r_mv + I*i_mv;
							epmu[J_sum + 5*L[0]*L[1]] = 1./(r_mw + I*i_mw);
							J_sum++;
							goto End_of_uv;
						}
					}
				}
			}
		}
		End_of_uv:;
		if(J_sum == L[0]*L[1]) goto End_of_data;
	}
	fprintf(stderr,"Read error @ read_epmu: File %s, J_sum = %ld, NU = %ld, NV = %ld\n", Yeex, J_sum, J_sum%L[0], J_sum/L[0]);
	exit(1);
	End_of_data:;

	if(fclose(fp_i) != 0) {
		fprintf(stderr,"fclose error after data file\n");
		exit(1);
	}
}
/*void read_epmu(char Yeex[], const long L[4], double complex epmu[6*L[0]*L[1]])
{
// L[4]             : L[0] = L, L[1] = M, L[2] = B_u and L[3] = B_v.
// epmu[6*L[0]*L[1]]: epmu[l + L[0]*m + 0*L[0]*L[1]] = epsi_u(l,m), epmu[l + L[0]*m + 1*L[0]*L[1]] = epsi_v(l,m), epmu[l + L[0]*m + 2*L[0]*L[1]] = 1/epsi_w(l,m),
//                    epmu[l + L[0]*m + 3*L[0]*L[1]] =   mu_u(l,m), epmu[l + L[0]*m + 4*L[0]*L[1]] =   mu_v(l,m), epmu[l + L[0]*m + 5*L[0]*L[1]] =   1/mu_w(l,m).
//
	char buf[BUFSIZE];
	FILE *fp_i;
	fp_i = fopen(Yeex,"r");
	for(int JV = 0 ; JV < L[1] ; JV++) { 
		for(int JU = 0 ; JU < L[0] ; JU++) { 
			int NU, NV, SubN;
//			double dummy;
			if(fgets(buf, sizeof buf, fp_i) == NULL){
				fprintf(stderr,"fgets error!: %s %d, %d-0\n", Yeex, JU, JV);
				exit(1);
			}
			double r_mu, i_mu, r_mv, i_mv, r_ew, i_ew;
			if(sscanf(buf,"%d %d %d %lf %lf %lf %lf %lf %lf", &NU, &NV, &SubN, &r_mu, &i_mu, &r_mv, &i_mv, &r_ew, &i_ew) != 9){
				fprintf(stderr,"input error!: %s %d, %d-0\n", Yeex, JU, JV);
				exit(1);
			}
			if(NU != JU || NV != JV || SubN != 0){
				fprintf(stderr,"File %s, NU != JU || NV != JV || SubN != 0: %d, %d, %d \n", Yeex, NU, NV, SubN);
				exit(1);
			}
			if(fgets(buf, sizeof buf, fp_i) == NULL){
				fprintf(stderr,"fgets error!: %s, %d, %d-1\n", Yeex, JU, JV);
				exit(1);
			}
			double r_eu, i_eu, r_ev, i_ev, r_mw, i_mw;
			if(sscanf(buf,"%d %d %d %lf %lf %lf %lf %lf %lf", &NU, &NV, &SubN, &r_eu, &i_eu, &r_ev, &i_ev, &r_mw, &i_mw) != 9){
				fprintf(stderr,"input error!: %s, %d, %d-1\n", Yeex, JU, JV);
				exit(1);
			}
			if(NU != JU || NV != JV || SubN != 1){
				fprintf(stderr,"File %s, NU != JU || NV != JV || SubN != 1: %d, %d, %d \n", Yeex, NU, NV, SubN);
				exit(1);
			}
			epmu[JU + L[0]*JV + 0*L[0]*L[1]] = r_eu + I*i_eu;
			epmu[JU + L[0]*JV + 1*L[0]*L[1]] = r_ev + I*i_ev;
			epmu[JU + L[0]*JV + 2*L[0]*L[1]] = 1./(r_ew + I*i_ew);
			epmu[JU + L[0]*JV + 3*L[0]*L[1]] = r_mu + I*i_mu;
			epmu[JU + L[0]*JV + 4*L[0]*L[1]] = r_mv + I*i_mv;
			epmu[JU + L[0]*JV + 5*L[0]*L[1]] = 1./(r_mw + I*i_mw);
		}
	}
	fclose(fp_i);
}*/
