/* This header file defines numerical and physical constants for simulation. Aug/18/2010   */
/*                                                          Last modified on Dec/24/2014   */

#define BUFSIZE 1024 /* buffer for fgets */
//#define EPS 5.e-19 // numerical minimum error//revised on Dec 24, 2014 

#define Pi 3.141592653589793238462643 /* circular constant */
#define Pi2 6.283185307179586476925286

//#define k_B 1.38054e-23 /* Boltzmann constant [J/K] */
//#define h_bar 1.05457266e-34 /* Planck constant over 2*Pi [J*s] */
//#define m_0 9.1093897e-31 /* free electron mass [kg] */
//#define q_e 1.60217733e-19 /* electron charge [C] */

#define epsilon_0 8.85418782e-12 /* permittivity of vacuum [F/m] */
#define mu_0 1.25663706e-6 /* permeability of vacuum [H/m] */
#define c_0 2.99792458e8 /* light velocity in vacuum [m/s] */

