/*|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
||||||||||||                              output_file of YeeSlice.                           ||||||||||||
||||||||||||                            Last updated on Dec 18, 2014                         ||||||||||||
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tgmath.h>
#include "constant.h"
void EPS_out(const char Yee[], const long slice[3], const long L[3], const long S_axis, 
				const double x[], const double y[], 
				const double WE_v[], const double WE_u[], const double WE_w[], 
				const double scale_range[2], const long func_para[3], const long boundary_SW);
void EPS_scale(const char Yee[], const long func_para[3]);

void output_file(const char Yee[], const long slice[3], const long L[3], 
					const double x[], const double y[], const double z[], 
					const double scale_range[2], const long func_para[3], const long boundary_SW)
{
	if(slice[0] < 0 || slice[0] >= L[0]){
		fprintf(stderr,"slice[0] < 0 || slice[0] >= L[0]\n");
		exit(1);
	}

	double *UE_u, *UA_u, *UE_v, *UA_v, *UE_w, *UA_w;
// start revision on Dec 18, 2014.
	UE_u = malloc(sizeof(double)*(L[1]+1)*(L[2]+1));
	UA_u = malloc(sizeof(double)*(L[1]+1)*(L[2]+1));
	UE_v = malloc(sizeof(double)*(L[1]+1)*(L[2]+1));
	UA_v = malloc(sizeof(double)*(L[1]+1)*(L[2]+1));
	UE_w = malloc(sizeof(double)*(L[1]+1)*(L[2]+1));
	UA_w = malloc(sizeof(double)*(L[1]+1)*(L[2]+1));
// end revision on Dec 18, 2014.
	
	double *VE_u, *VA_u, *VE_v, *VA_v, *VE_w, *VA_w;
// start revision on Dec 18, 2014.
	VE_u = malloc(sizeof(double)*(L[2]+1)*(L[0]+1));
	VA_u = malloc(sizeof(double)*(L[2]+1)*(L[0]+1));
	VE_v = malloc(sizeof(double)*(L[2]+1)*(L[0]+1));
	VA_v = malloc(sizeof(double)*(L[2]+1)*(L[0]+1));
	VE_w = malloc(sizeof(double)*(L[2]+1)*(L[0]+1));
	VA_w = malloc(sizeof(double)*(L[2]+1)*(L[0]+1));
// end revision on Dec 18, 2014.

	double *WE_u, *WA_u, *WE_v, *WA_v, *WE_w, *WA_w;
// start revision on Dec 18, 2014.
	WE_u = malloc(sizeof(double)*(L[0]+1)*(L[1]+1));
	WA_u = malloc(sizeof(double)*(L[0]+1)*(L[1]+1));
	WE_v = malloc(sizeof(double)*(L[0]+1)*(L[1]+1));
	WA_v = malloc(sizeof(double)*(L[0]+1)*(L[1]+1));
	WE_w = malloc(sizeof(double)*(L[0]+1)*(L[1]+1));
	WA_w = malloc(sizeof(double)*(L[0]+1)*(L[1]+1));
// end revision on Dec 18, 2014.

	for(long JW = 0 ; JW < L[2] ; JW++) { 
		char read_file[BUFSIZE];
		sprintf(read_file,"%s_Med%ld.dat", Yee, JW);
		FILE *fp_i;
		fp_i = fopen(read_file,"r");
		for(long JV = 0 ; JV < L[1] ; JV++) { 
			for(long JU = 0 ; JU < L[0] ; JU++) { 
				double E_v = 0.;//revised on Dec 18, 2014
				double E_u = 0.;//revised on Dec 18, 2014
				double E_w = 0.;//revised on Dec 18, 2014
				double A_v = 0.;//revised on Dec 18, 2014
				double A_u = 0.;//revised on Dec 18, 2014
				double A_w = 0.;//revised on Dec 18, 2014
				for(long KW = 0 ; KW < 2 ; KW++) { 
					while(fgets(read_file, sizeof( read_file ), fp_i) != NULL) { 
						long NU, NV, SubW;
						double r_v, i_v, r_u, i_u, r_w, i_w;
						if(sscanf(read_file,"%ld %ld %ld %lf %lf %lf %lf %lf %lf", 
										&NU, &NV, &SubW, 
										&r_v, &i_v, 
										&r_u, &i_u, 
										&r_w, &i_w) == 9){
							if(NU == JU && NV == JV && SubW == KW) {
								if(KW == 0){
									E_w = hypot(r_w,i_w);
									A_w = atan2(i_w,r_w);
									goto NEXT_row;
								}
								if(KW == 1){
									E_v = hypot(r_v,i_v);
									A_v = atan2(i_v,r_v);
									E_u = hypot(r_u,i_u);
									A_u = atan2(i_u,r_u);
									goto NEXT_row;
								}
							}
						}
					}
					fprintf(stderr,"read error in output_file!: %ld, %ld, %ld\n", JU, JV, KW);
					exit(1);
					NEXT_row:;
				}
				if(slice[0] == JU){
					 UE_u[JV+(L[1]+1)*JW] = E_u;
					 UA_u[JV+(L[1]+1)*JW] = A_u;
					 UE_v[JV+(L[1]+1)*JW] = E_v;
					 UA_v[JV+(L[1]+1)*JW] = A_v;
					 UE_w[JV+(L[1]+1)*JW] = E_w;
					 UA_w[JV+(L[1]+1)*JW] = A_w;
				}
				if(slice[1] == JV){
					 VE_u[JW+(L[2]+1)*JU] = E_u;
					 VA_u[JW+(L[2]+1)*JU] = A_u;
					 VE_v[JW+(L[2]+1)*JU] = E_v;
					 VA_v[JW+(L[2]+1)*JU] = A_v;
					 VE_w[JW+(L[2]+1)*JU] = E_w;
					 VA_w[JW+(L[2]+1)*JU] = A_w;
				}
				if(slice[2] == JW){
					 WE_u[JU+(L[0]+1)*JV] = E_u;
					 WA_u[JU+(L[0]+1)*JV] = A_u;
					 WE_v[JU+(L[0]+1)*JV] = E_v;
					 WA_v[JU+(L[0]+1)*JV] = A_v;
					 WE_w[JU+(L[0]+1)*JV] = E_w;
					 WA_w[JU+(L[0]+1)*JV] = A_w;
				}
			}
		}
		fclose(fp_i);
	}

// start revision on Dec 18, 2014.
	for(long JW = 0 ; JW < L[2] ; JW++){
		UE_u[L[1]+(L[1]+1)*JW] = UE_u[0+(L[1]+1)*JW];
		UA_u[L[1]+(L[1]+1)*JW] = UA_u[0+(L[1]+1)*JW];
		UE_v[L[1]+(L[1]+1)*JW] = UE_v[0+(L[1]+1)*JW];
		UA_v[L[1]+(L[1]+1)*JW] = UA_v[0+(L[1]+1)*JW];
		UE_w[L[1]+(L[1]+1)*JW] = UE_w[0+(L[1]+1)*JW];
		UA_w[L[1]+(L[1]+1)*JW] = UA_w[0+(L[1]+1)*JW];
	}
	for(long JV = 0 ; JV <= L[1] ; JV++) { 
		UE_u[JV+(L[1]+1)*L[2]] = UE_u[JV+(L[1]+1)*(L[2]-1)];
		UA_u[JV+(L[1]+1)*L[2]] = UA_u[JV+(L[1]+1)*(L[2]-1)];
		UE_v[JV+(L[1]+1)*L[2]] = UE_v[JV+(L[1]+1)*(L[2]-1)];
		UA_v[JV+(L[1]+1)*L[2]] = UA_v[JV+(L[1]+1)*(L[2]-1)];
		UE_w[JV+(L[1]+1)*L[2]] = UE_w[JV+(L[1]+1)*(L[2]-1)];
		UA_w[JV+(L[1]+1)*L[2]] = UA_w[JV+(L[1]+1)*(L[2]-1)];
	}
//
	for(long JU = 0 ; JU < L[0] ; JU++) {
		VE_u[L[2]+(L[2]+1)*JU] = VE_u[L[2]-1+(L[2]+1)*JU];
		VA_u[L[2]+(L[2]+1)*JU] = VA_u[L[2]-1+(L[2]+1)*JU];
		VE_v[L[2]+(L[2]+1)*JU] = VE_v[L[2]-1+(L[2]+1)*JU];
		VA_v[L[2]+(L[2]+1)*JU] = VA_v[L[2]-1+(L[2]+1)*JU];
		VE_w[L[2]+(L[2]+1)*JU] = VE_w[L[2]-1+(L[2]+1)*JU];
		VA_w[L[2]+(L[2]+1)*JU] = VA_w[L[2]-1+(L[2]+1)*JU];
	}
	for(long JW = 0 ; JW <= L[2] ; JW++){
		VE_u[JW+(L[2]+1)*L[0]] = VE_u[JW+(L[2]+1)*0];
		VA_u[JW+(L[2]+1)*L[0]] = VA_u[JW+(L[2]+1)*0];
		VE_v[JW+(L[2]+1)*L[0]] = VE_v[JW+(L[2]+1)*0];
		VA_v[JW+(L[2]+1)*L[0]] = VA_v[JW+(L[2]+1)*0];
		VE_w[JW+(L[2]+1)*L[0]] = VE_w[JW+(L[2]+1)*0];
		VA_w[JW+(L[2]+1)*L[0]] = VA_w[JW+(L[2]+1)*0];
	}
//
	for(long JU = 0 ; JU < L[0] ; JU++) {
		WE_u[JU+(L[0]+1)*L[1]] = WE_u[JU+(L[0]+1)*0];
		WA_u[JU+(L[0]+1)*L[1]] = WA_u[JU+(L[0]+1)*0];
		WE_v[JU+(L[0]+1)*L[1]] = WE_v[JU+(L[0]+1)*0];
		WA_v[JU+(L[0]+1)*L[1]] = WA_v[JU+(L[0]+1)*0];
		WE_w[JU+(L[0]+1)*L[1]] = WE_w[JU+(L[0]+1)*0];
		WA_w[JU+(L[0]+1)*L[1]] = WA_w[JU+(L[0]+1)*0];
	}
	for(long JV = 0 ; JV <= L[1] ; JV++) { 
		WE_u[L[0]+(L[0]+1)*JV] = WE_u[0+(L[0]+1)*JV];
		WA_u[L[0]+(L[0]+1)*JV] = WA_u[0+(L[0]+1)*JV];
		WE_v[L[0]+(L[0]+1)*JV] = WE_v[0+(L[0]+1)*JV];
		WA_v[L[0]+(L[0]+1)*JV] = WA_v[0+(L[0]+1)*JV];
		WE_w[L[0]+(L[0]+1)*JV] = WE_w[0+(L[0]+1)*JV];
		WA_w[L[0]+(L[0]+1)*JV] = WA_w[0+(L[0]+1)*JV];
	}
// end revision on Dec 18, 2014.

	EPS_out(Yee, slice, L, 2, x, y, WE_v, WE_u, WE_w, scale_range, func_para, boundary_SW);
	free(WE_u);
	free(WA_u);
	free(WE_v);
	free(WA_v);
	free(WE_w);
	free(WA_w);
	
	EPS_out(Yee, slice, L, 1, z, x, VE_u, VE_w, VE_v, scale_range, func_para, boundary_SW);
	free(VE_u);
	free(VA_u);
	free(VE_v);
	free(VA_v);
	free(VE_w);
	free(VA_w);
	
	EPS_out(Yee, slice, L, 0, y, z, UE_w, UE_v, UE_u, scale_range, func_para, boundary_SW);
	free(UE_u);
	free(UA_u);
	free(UE_v);
	free(UA_v);
	free(UE_w);
	free(UA_w);
	
	EPS_scale(Yee, func_para);
}
