/* This program is Output Program of BottomTop. Aug/08/2012   */
/*                     w/o LAPACK version                     */
/*     Main and sub programs were coded by Tatsuya Usuki.     */
/*                            It was modified in Dec/26/2014  */
#include <tgmath.h>
#include <float.h>
#include <tgmath.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
//#include "constant.h"
#define BUFSIZE 1024 // buffer for fgets
#define Pi 3.141592653589793238462643 // circular constant
#define Pi2 6.283185307179586476925286
#define epsilon_0 8.85418782e-12 // permittivity of vacuum [F/m]
#define mu_0 1.25663706e-6 // permeability of vacuum [H/m]
#define c_0 2.99792458e8 // light velocity in vacuum [m/s]

//
// * --> Main_calc ---- mode_calc --> *
//
void mode_calc(char Yeex[], const long L[4], const int solver_sw, const double fg[(L[0]+L[1])*2], 
				double RU[4*L[0]*L[1]*L[0]*L[1]], double IU[4*L[0]*L[1]*L[0]*L[1]], 
				double RB[2*L[0]*L[1]], double IB[2*L[0]*L[1]]);

void Main_calc(const char Yee[], const double Lambda, const int LMN[3], 
				const double dxdu[(LMN[0]+LMN[1]+LMN[2])*2], const int Buv[2], const int solver_sw)
{
//                LAPACK                 : dgeev_ when solver_sw == 0,
// Original long double-precision routine: lgeev_ when solver_sw != 0.
	long L[4]={(long) LMN[0], (long) LMN[1], (long) Buv[0], (long) Buv[1]};// L[0]=L, L[1]=M, L[2]=B_u, L[4]=B_v.
	double k0 = Pi2/Lambda;
	double *fg;
	fg = malloc(sizeof(double)*(LMN[0]+LMN[1])*2);
	                              // f_k (j) = fg[2*j + k] where 0 <= j < LMN[0] and k = 0 or 1,
	                              // g_k (j) = fg[2*(j+LMN[0]) + k] where 0 <= j < LMN[1] and k = 0 or 1,
	for(long J_LMN = 0 ; J_LMN < (LMN[0]+LMN[1])*2 ; J_LMN++) fg[J_LMN] = sqrt(1./(k0*dxdu[J_LMN]));
		                          // dxdu_k (j) = dxdu[2*j + k] where 0 <= j < LMN[0] and k = 0 or 1,
		                          // dydv_k (j) = dxdu[2*(j+LMN[0]) + k] where 0 <= j < LMN[1] and k = 0 or 1.
	double h_bt[2] = {sqrt(1./(k0*dxdu[(LMN[0]+LMN[1])*2])), sqrt(1./(k0*dxdu[(LMN[0]+LMN[1]+LMN[2])*2 - 1]))};
	for(int J_bt = 0 ; J_bt < 2 ; J_bt++) { 
		char Yeex[BUFSIZE];
		sprintf(Yeex,"%s_Med%d.dat", Yee, J_bt*(LMN[2]-1));//Yeex is input-file name.
		fprintf(stderr,"%s\n", Yeex);

		long MM = 2*L[0]*L[1];
		double *RU;
		RU = malloc(sizeof(double)*MM*MM);
		double *IU;
		IU = malloc(sizeof(double)*MM*MM);
		double *RB;
		RB = malloc(sizeof(double)*MM);
		double *IB;
		IB = malloc(sizeof(double)*MM);

		mode_calc(Yeex, L, solver_sw, fg, RU, IU, RB, IB);
		
		FILE *fp_o;//Yeex is changed to output-file name.
		if(J_bt == 0) {
			sprintf(Yeex,"%sBottom.dat", Yee);
		}
		else {
			sprintf(Yeex,"%sTop.dat", Yee);
		}
		fp_o = fopen(Yeex,"w");
		if (fp_o == NULL){
			fprintf(stderr,"open error!: open output-file!\n");
			exit(1);
		}
		time_t timer_s = time(0);
		fprintf(fp_o,"# File name : ./%s on %s# Exe-file  : ./BottomTop (Updated on Dec 26, 2014)\n", Yeex, ctime(&timer_s));
		if(solver_sw == 0) fprintf(fp_o,"# This is a version w/o LAPACK.\n# Eigenproblem solver: lgeev_ (long double-precision)\n");
		if(solver_sw != 0) fprintf(fp_o,"# Eigenproblem solver: lgeev_ (long double-precision)\n");
		fprintf(fp_o,"# Column_no. creal((Beta_pseudo)^2) cimag((Beta_pseudo)^2) creal(Beta) cimag(Beta)\n");
		for(long J_column = 0 ; J_column < MM ; J_column++) {
//			double complex Lambda2 = RB[J_column] + I*IB[J_column];
//			double complex Beta = 2.*asin(sqrt(Lambda2)/(2.*h_bt[J_bt]*h_bt[J_bt]));
			double complex Beta = 0.;//revised on Dec 26, 2014
			if(IB[J_column] == 0.){
				if(RB[J_column] > 0.){
					Beta = 2.*asin(sqrt(RB[J_column])/(2.*h_bt[J_bt]*h_bt[J_bt])) + I*0.;
				}else{
					Beta = 0. + 2.*I*asinh(sqrt(-RB[J_column])/(2.*h_bt[J_bt]*h_bt[J_bt]));
				}
			}else{
				Beta = 2.*asin(sqrt(RB[J_column] + I*IB[J_column])/(2.*h_bt[J_bt]*h_bt[J_bt]));
			}//revised on Dec 24, 2014
			if(cimag(Beta) < 0.) Beta = -Beta;
			fprintf(fp_o,"%ld %.20E %.20E %.20E %.20E\n", J_column, RB[J_column], IB[J_column], creal(Beta), cimag(Beta));
		}
		free(RB);
		free(IB);
		for(long J_column = 0 ; J_column < MM ; J_column++) {
			fprintf(fp_o,"\nRe_eigenvector(%ld) Im_eigenvector(%ld)\n", J_column, J_column);
			for(long J_line = 0 ; J_line < MM ; J_line++) {
				fprintf(fp_o,"%.20E %.20E\n", RU[J_line + MM*J_column], IU[J_line + MM*J_column]);
			}
		}
		free(RU);
		free(IU);
		if(fclose(fp_o) != 0) {
			fprintf(stderr,"fclose error after output_file\n");
			exit(1);
		}
	}
	free(fg);
}
//
// * --> mode_calc ---- read_epmu
//                  |                 
//                   -- M_EH (at "M_EHHE.c")
//                  |                 
//                   -- M_HE (at "M_EHHE.c")
//                  |                 
//                   -- HDQR_calc ---- lgeev_ (at "lgeev_hEISPACK.c")
//                  |              |    
//                  |               -- dgeev_ (at LAPACK)  
//                  |                 
//                   -- Eigenvalue_sort
//                  |                 
//                   -- Eigenvector_norm
//
void read_epmu(char Yeex[], const long L[4], double complex epmu[6*L[0]*L[1]]);
void M_EH(const long L[4], const double complex epmu[6*L[0]*L[1]], const double fg[(L[0]+L[1])*2], 
			const double complex Psi_i[L[0]*L[1]*4], const long Pshift_i, 
			double complex Psi_o[L[0]*L[1]*4], const long Pshift_o);
void M_HE(const long L[4], const double complex epmu[6*L[0]*L[1]], const double fg[(L[0]+L[1])*2], 
			const double complex Psi_i[L[0]*L[1]*4], const long Pshift_idgeev, 
			double complex Psi_o[L[0]*L[1]*4], const long Pshift_o);
long HDQR_calc(const int solver_sw, const long NA, double R[NA*NA], double ER[NA], double EI[NA], 
				double VR[NA*NA], double VI[NA*NA]);
void Eigenvalue_sort(const long KA, double ZER[KA], double ZEI[KA], double ZEVR[KA*KA], double ZEVI[KA*KA]);
void Eigenvector_norm(const long L[4], const double complex epmu[6*L[0]*L[1]], const double fg[(L[0]+L[1])*2],
		 double RU[4*L[0]*L[1]*L[0]*L[1]], double IU[4*L[0]*L[1]*L[0]*L[1]]);

void mode_calc(char Yeex[], const long L[4], const int solver_sw, const double fg[(L[0]+L[1])*2], 
				double RU[4*L[0]*L[1]*L[0]*L[1]], double IU[4*L[0]*L[1]*L[0]*L[1]], 
				double RB[2*L[0]*L[1]], double IB[2*L[0]*L[1]])
{
// L[4]             : L[0] = L, L[1] = M, L[2] = B_u and L[3] = B_v.
// epmu[6*L[0]*L[1]]: epmu[l + L[0]*m + 0*L[0]*L[1]] = epsi_u(l,m), epmu[l + L[0]*m + 1*L[0]*L[1]] = epsi_v(l,m), epmu[l + L[0]*m + 2*L[0]*L[1]] = 1/epsi_w(l,m),
//                    epmu[l + L[0]*m + 3*L[0]*L[1]] =   mu_u(l,m), epmu[l + L[0]*m + 4*L[0]*L[1]] =   mu_v(l,m), epmu[l + L[0]*m + 5*L[0]*L[1]] =   1/mu_w(l,m).
// fg[(L[0]+L[1])*2]: fg[2*l + j] = f_j(l),  fg[2*(L[0]+m) + j] = g_j(m), where j = 0 or 1.
//
	double complex *epmu;
	epmu = malloc(sizeof(double complex)*6*L[0]*L[1]);

	read_epmu(Yeex, L, epmu);
	
	long MM = 2*L[0]*L[1];
	double *A;
	A = malloc(sizeof(double)*MM*MM);
	for(long J_column = 0 ; J_column < MM ; J_column++) {
		double complex *U_ini;
		U_ini = malloc(sizeof(double complex)*MM);
		double complex *U_out;
		U_out = malloc(sizeof(double complex)*MM);
		for(long J_line = 0 ; J_line < MM ; J_line++) {
			U_ini[J_line] = 0. + I*0.;
		}
		U_ini[J_column] = 1. + I*0.;
		M_EH(L, epmu, fg, U_ini, 0, U_out, 0);
		M_HE(L, epmu, fg, U_out, 0, U_ini, 0);
		for(long J_line = 0 ; J_line < MM ; J_line++) {
			A[J_line + MM*J_column] = creal(U_ini[J_line]);
		}
		free(U_ini);
		free(U_out);
	}

	time_t timer_s = time(0);
	fprintf(stderr,"# HDQR_calc start time= %s\n", ctime(&timer_s));
	
	long ierr = HDQR_calc(solver_sw, MM, A, RB, IB, RU, IU);
	free(A);
	if(ierr != 0){
		fprintf(stderr,"HDQR_calc error = %ld \n", ierr);
		exit(1);
	}
	
	Eigenvalue_sort(MM,RB,IB,RU,IU);
	Eigenvector_norm(L, epmu, fg, RU, IU);
	free(epmu);
	time_t timer_f = time(0);
	double t_span = difftime(timer_f,timer_s);
	fprintf(stderr,"# Dimension= %ld, exec time= %1.1f sec, state = %ld (0: normal end)\n\n", MM, t_span, ierr);
}
/*void dgeev_(char *N, char *V, int *N0, double *R, int *N1, double *ER, double *EI, 
			double *vdummy, int *ndummy, double *VR, int *N2, double *work, int *n3, int *info0);*/
long lgeev_(const long N, long double A[N*N], long double E_real[N], long double E_imag[N], long double V_real[N*N]);
long HDQR_calc(const int solver_sw, const long NA, double R[NA*NA], double ER[NA], double EI[NA], 
				double VR[NA*NA], double VI[NA*NA])
{
	long info = 0;
//	if(solver_sw != 0){
		long double *ERL;
		ERL = malloc(sizeof(long double)*NA);
		long double *EIL;
		EIL = malloc(sizeof(long double)*NA);
		long double *VRL;
		VRL = malloc(sizeof(long double)*NA*NA);
		long double *RL;
		RL = malloc(sizeof(long double)*NA*NA);
		for(long i = 0 ; i < NA ; i++) {
			for(long j = 0 ; j < NA ; j++) {
				RL[j+i*NA] = R[j+i*NA];
			}
		} 
		fprintf(stderr,"Original long double-precision routine: lgeev_ start!\n");
		info = lgeev_(NA, RL, ERL, EIL, VRL);
		free(RL);
		for(long i = 0 ; i < NA ; i++) {
			ER[i] = ERL[i];
			EI[i] = EIL[i];
		}
		free(ERL);
		free(EIL);
		for(long i = 0 ; i < NA ; i++) {
			for(long j = 0 ; j < NA ; j++) {
				VR[j+i*NA] = VRL[j+i*NA];
			}
		}
		free(VRL);
/*	}else{//Comment out this scope unless using LAPACK library.
		int n3 = 4 *((int) NA);
		double *work;
		work = malloc(sizeof(double)*n3);
		double vdummy[1*1];
		int ndummy = 1;
		int NA0 = (int) NA;
		int NA1 = NA0;
		int NA2 = NA1;
		int info0 = 0; 
		// change "long" to "int" in order to avoid ambiguity for LAPACK on 20141107
		fprintf(stderr,"dgeev_ start!\n");
		dgeev_("N", "V", &NA0, R, &NA1, ER, EI, vdummy, &ndummy, VR, &NA2, work, &n3, &info0);
		free( work );
		info = (long) info0;
	}
*/	
	for(long i = 0 ; i < NA ; i++) {
		for(long j = 0 ; j < NA ; j++) {
			VI[j+i*NA] = 0.e0;
		}
	} 
	for(long i = 0 ; i < NA-1 ; i++) {
		if(fabs(EI[i]) > 0.e0) { 
			for(long j = 0 ; j < NA ; j++) {
				VI[j+i*NA] = VR[j+(i+1)*NA];
				VI[j+(i+1)*NA] = -VI[j+i*NA];
				VR[j+(i+1)*NA] = VR[j+i*NA];
			}
			i++;
		}
	}
	return(info);
}
void Eigenvector_norm(const long L[4], const double complex epmu[6*L[0]*L[1]], const double fg[(L[0]+L[1])*2],
		 double RU[4*L[0]*L[1]*L[0]*L[1]], double IU[4*L[0]*L[1]*L[0]*L[1]])
{
	long MM = 2*L[0]*L[1];
	for(long J_column = 0 ; J_column < MM ; J_column++) {
		double complex *U_ini;
		U_ini = malloc(sizeof(double complex)*MM);
		double complex *U_out;
		U_out = malloc(sizeof(double complex)*MM);
		for(long J_line = 0 ; J_line < MM ; J_line++) {
			U_ini[J_line] = RU[J_line + J_column*MM] + I*IU[J_line + J_column*MM];
		}
		M_EH(L, epmu, fg, U_ini, 0, U_out, 0);
		double complex Sum = 0. + I*0.;
		for(long J_line = 0 ; J_line < MM ; J_line++) {
			Sum += U_ini[J_line]*U_out[J_line];
		}
		double complex Norm = sqrt(Sum);
		for(long J_line = 0 ; J_line < MM ; J_line++) {
			double complex c1 = U_ini[J_line]/Norm;
			RU[J_line + J_column*MM] = creal(c1);
			IU[J_line + J_column*MM] = cimag(c1);
		}
	}
}
void read_epmu(char Yeex[], const long L[4], double complex epmu[6*L[0]*L[1]])
{
// L[4]             : L[0] = L, L[1] = M, L[2] = B_u and L[3] = B_v.
// epmu[6*L[0]*L[1]]: epmu[l + L[0]*m + 0*L[0]*L[1]] = epsi_u(l,m), epmu[l + L[0]*m + 1*L[0]*L[1]] = epsi_v(l,m), epmu[l + L[0]*m + 2*L[0]*L[1]] = 1/epsi_w(l,m),
//                    epmu[l + L[0]*m + 3*L[0]*L[1]] =   mu_u(l,m), epmu[l + L[0]*m + 4*L[0]*L[1]] =   mu_v(l,m), epmu[l + L[0]*m + 5*L[0]*L[1]] =   1/mu_w(l,m).
//
	char buf[BUFSIZE];
	FILE *fp_i;
	fp_i = fopen(Yeex,"r");
	if (fp_i == NULL){
		fprintf(stderr,"Do not open data file @ read_epmu!\n");
		exit(1);
	}
	long J_sum = 0;
	while(fgets(buf, sizeof( buf ), fp_i) != NULL) { 
		long NU, NV, SubN;
		double r_mu, i_mu, r_mv, i_mv, r_ew, i_ew;
		if(sscanf(buf,"%ld %ld %ld %lf %lf %lf %lf %lf %lf", 
			&NU, &NV, &SubN, &r_mu, &i_mu, &r_mv, &i_mv, &r_ew, &i_ew) == 9){
			if(NU == J_sum%L[0] && NV == (J_sum/L[0]) && SubN == 0){
				while(fgets(buf, sizeof( buf ), fp_i) != NULL) { 
					double r_eu, i_eu, r_ev, i_ev, r_mw, i_mw;
					if(sscanf(buf,"%ld %ld %ld %lf %lf %lf %lf %lf %lf",
						 &NU, &NV, &SubN, &r_ev, &i_ev, &r_eu, &i_eu, &r_mw, &i_mw) == 9){
						if(NU == J_sum%L[0] && NV == (J_sum/L[0]) && SubN == 1) {
							epmu[J_sum + 0*L[0]*L[1]] = r_eu + I*i_eu;
							epmu[J_sum + 1*L[0]*L[1]] = r_ev + I*i_ev;
							epmu[J_sum + 2*L[0]*L[1]] = 1./(r_ew + I*i_ew);
							epmu[J_sum + 3*L[0]*L[1]] = r_mu + I*i_mu;
							epmu[J_sum + 4*L[0]*L[1]] = r_mv + I*i_mv;
							epmu[J_sum + 5*L[0]*L[1]] = 1./(r_mw + I*i_mw);
							J_sum++;
							goto End_of_uv;
						}
					}
				}
			}
		}
//		fprintf(stderr,"input error @ read_epmu!: File %s, J_sum = %ld, NU = %ld, NV = %ld\n", Yeex, J_sum, J_sum%L[0], J_sum/L[0]);
//		exit(1);
		End_of_uv:;
		if(J_sum == L[0]*L[1]) goto End_of_data;
	}
	fprintf(stderr,"Read error @ read_epmu: File %s, J_sum = %ld, NU = %ld, NV = %ld\n", Yeex, J_sum, J_sum%L[0], J_sum/L[0]);
	exit(1);
	End_of_data:;

	if(fclose(fp_i) != 0) {
		fprintf(stderr,"fclose error after data file\n");
		exit(1);
	}
}
void Eigenvalue_sort(const long KA, double ZER[KA], double ZEI[KA], double ZEVR[KA*KA], double ZEVI[KA*KA])
{
	double ER0, EI0;
	double *EVR0;
		EVR0 = malloc(sizeof(double)*KA);
	double *EVI0;
		EVI0 = malloc(sizeof(double)*KA);
	
	for(long J0 = 0 ; J0 < KA-1 ; J0++) {
		for(long K0 = J0+1 ; K0 < KA ; K0++) {
			if((ZER[J0] < ZER[K0] && fabs(ZEI[J0]) == 0. && fabs(ZEI[K0]) == 0.) || (fabs(ZEI[J0]) > 0. && fabs(ZEI[K0]) == 0.)){
				ER0 = ZER[J0];
				EI0 = ZEI[J0];
				for(long J1 = 0 ; J1 < KA ; J1++) {
					EVR0[J1] = ZEVR[J1+J0*KA];
					EVI0[J1] = ZEVI[J1+J0*KA];
				}
				ZER[J0] = ZER[K0];
				ZEI[J0] = ZEI[K0];
				for(long J1 = 0 ; J1 < KA ; J1++) {
					ZEVR[J1+J0*KA] = ZEVR[J1+K0*KA];
					ZEVI[J1+J0*KA] = ZEVI[J1+K0*KA];
				}
				ZER[K0] = ER0;
				ZEI[K0] = EI0;
				for(long J1 = 0 ; J1 < KA ; J1++) {
					ZEVR[J1+K0*KA] = EVR0[J1];
					ZEVI[J1+K0*KA] = EVI0[J1];
				}
			}
		}
	}
	free(EVR0);
	free(EVI0);
}

