/*|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
||||||||||||                                  function_gnuplot                               ||||||||||||
||||||||||||                            Last updated on Dec 25, 2014                         ||||||||||||
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*/
#include <tgmath.h>
#include <stdio.h>
#include <stdlib.h>
#define Pi 3.141592653589793238462643 /* circular constant */

double function_gnuplot(double x, long N)
{
	if(x > 1.) x = 1.;
	if(x < 0.) x = 0.;
	
	if(N < 0) {
		x = 1. - x;
		N = -N;
	}
	
	if(N > 36) {
		fprintf(stderr,"N error!: N = %ld\n", N);
		exit(1);
	}
	
	double y = 0.;//revised on Dec 25, 2014
	if(N == 0) {
		y = 0.;
		goto rgbf_end;
	}
	if(N == 1) {
		y = 0.5;
		goto rgbf_end;
	}
	if(N == 2) {
		y = 1.;
		goto rgbf_end;
	}
	if(N == 3) {
		y = x;
		goto rgbf_end;
	}
	if(N == 4) {
		y = x*x;
		goto rgbf_end;
	}
	if(N == 5) {
		y = x*x*x;
		goto rgbf_end;
	}
	if(N == 6) {
		y = x*x*x*x;
		goto rgbf_end;
	}
	if(N == 7) {
		y = sqrt(x);
		goto rgbf_end;
	}
	if(N == 8) {
		y = sqrt(sqrt(x));
		goto rgbf_end;
	}
	if(N == 9) {
		y = sin(x*0.5*Pi);
		goto rgbf_end;
	}
	if(N == 10) {
		y = cos(x*0.5*Pi);
		goto rgbf_end;
	}
	if(N == 11) {
		y = fabs(x-0.5);
		goto rgbf_end;
	}
	if(N == 12) {
		y = (2.*x-1.)*(2.*x-1.);
		goto rgbf_end;
	}
	if(N == 13) {
		y = sin(x*Pi);
		goto rgbf_end;
	}
	if(N == 14) {
		y = fabs(cos(x*Pi));
		goto rgbf_end;
	}
	if(N == 15) {
		y = sin(x*2.*Pi);
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 16) {
		y = cos(x*2.*Pi);
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 17) {
		y = fabs(sin(x*2.*Pi));
		goto rgbf_end;
	}
	if(N == 18) {
		y = fabs(cos(x*2.*Pi));
		goto rgbf_end;
	}
	if(N == 19) {
		y = fabs(sin(x*4.*Pi));
		goto rgbf_end;
	}
	if(N == 20) {
		y = fabs(cos(x*4.*Pi));
		goto rgbf_end;
	}
	if(N == 21) {
		y = 3.*x;
		if(y > 1.) y = 1.;
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 22) {
		y = 3.*x - 1.;
		if(y > 1.) y = 1.;
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 23) {
		y = 3.*x - 2.;
		if(y > 1.) y = 1.;
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 24) {
		y = fabs(3.*x - 1.);
		if(y > 1.) y = 1.;
		goto rgbf_end;
	}
	if(N == 25) {
		y = fabs(3.*x - 2.);
		if(y > 1.) y = 1.;
		goto rgbf_end;
	}
	if(N == 26) {
		y = 0.5*(3.*x - 1.);
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 27) {
		y = 0.5*(3.*x - 2.);
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 28) {
		y = fabs(0.5*(3.*x - 1.));
		goto rgbf_end;
	}
	if(N == 29) {
		y = fabs(0.5*(3.*x - 2.));
		goto rgbf_end;
	}
	if(N == 30) {
		y = x/0.32-0.78125;
		if(y > 1.) y = 1.;
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 31) {
		y = 2*x-0.84;
		if(y > 1.) y = 1.;
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 32) {//		y = 4x;1;-2x+1.84;x/0.08-11.5;
		if(x < 0.25) {
			y = 4.*x;
		}
		else {
			if(x < 0.42) {
				y = 1.;
			}
			else {
				if(x < 0.92) {
					y = -2.*x+1.84;
				}
				else {
					y = x/0.08 - 11.5;
				}
			}
		}
		goto rgbf_end;
	}
	if(N == 33) {
		y = fabs(2.*x-0.5);
		if(y > 1.) y = 1.;
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 34) {
		y = 2.*x;
		if(y > 1.) y = 1.;
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 35) {
		y = 2.*x - 0.5;
		if(y > 1.) y = 1.;
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
	if(N == 36) {
		y = 2.*x - 1.;
		if(y < 0.) y = 0.;
		goto rgbf_end;
	}
// gnuplot> show palette rgbformulae
//           * there are 37 available rgb color mapping formulae:
//              0: 0               1: 0.5             2: 1
//              3: x               4: x^2             5: x^3
//              6: x^4             7: sqrt(x)         8: sqrt(sqrt(x))
//              9: sin(90x)       10: cos(90x)       11: |x-0.5|
//             12: (2x-1)^2       13: sin(180x)      14: |cos(180x)|
//             15: sin(360x)      16: cos(360x)      17: |sin(360x)|
//             18: |cos(360x)|    19: |sin(720x)|    20: |cos(720x)|
//             21: 3x             22: 3x-1           23: 3x-2
//             24: |3x-1|         25: |3x-2|         26: (3x-1)/2
//             27: (3x-2)/2       28: |(3x-1)/2|     29: |(3x-2)/2|
//             30: x/0.32-0.78125 31: 2*x-0.84       32: 4x;1;-2x+1.84;x/0.08-11.5
//             33: |2*x - 0.5|    34: 2*x            35: 2*x - 0.5
//             36: 2*x - 1
//           * negative numbers mean inverted=negative colour component
//           * thus the ranges in `set pm3d rgbformulae' are -36..36               
	rgbf_end:;
	if( y > 1. || y < 0. ) {//	if( y > 1. + EPS || y < - EPS ) {
		fprintf(stderr,"y error!: y = %g\n", y);
		exit(1);
	}
	return y;
}
