/*                  This program is Main Program of MatrixOut. Aug/28/2013                */
/*                    Main and sub programs were coded by Tatsuya Usuki.                  */
/*                                   Program language is C99.                             */
/*                                                                                        */
/*                                                         Last modified on Jan/07/2015.  */
#include <tgmath.h>
#include <float.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#define BUFSIZE 1024 /* buffer for fgets */
void input_file3(FILE *fp_i3, long *data_c, double scale_range[2], long func_para[3]);
long input_file1(FILE *fp_i);
void input_fileM(FILE *fp_i, const long Mat_no, const long Line_max, long Column_no[Line_max], long Row_no[Line_max], double MatData[Line_max]);
double function_gnuplot(double x, int N);

int main(int argc, char **argv)
{
	time_t timer_s = time(0);
	fprintf(stderr,"# `MatrixOut' starts on %s\n", ctime(&timer_s));
	if(argc != 3) {
		fprintf(stderr,"error: number of files \n");
		exit(1);
	}
	
	long Mat_no;
	long func_para[3] = {30,31,32};
	double scale_range[2];
	{
		FILE *fp_i;
		fp_i = fopen(argv[2],"r");
		if (fp_i == NULL){
			fprintf(stderr,"open error!: 2nd input-file!\n");
			exit(1);
		}
		input_file3(fp_i, &Mat_no, scale_range, func_para);
		fclose(fp_i);
	}
	fprintf(stderr,"Mat_no = %ld\n", Mat_no);
////////////////////////////////////////////////////////////
	FILE *fp_i;
	fp_i = fopen(argv[1],"r");
	if (fp_i == NULL){
		fprintf(stderr,"open error!: 1st input-file!\n");
		exit(1);
	}

	long Line_max = input_file1(fp_i);
	rewind(fp_i);
	fprintf(stderr,"Line_max = %ld\n", Line_max);
	
	long *Column_no, *Row_no;
	Column_no = malloc(sizeof(long)*Line_max);
	Row_no    = malloc(sizeof(long)*Line_max);
	double *MatData;
	MatData   = malloc(sizeof(double)*Line_max);
	
	input_fileM(fp_i, Mat_no, Line_max, Column_no, Row_no, MatData);
	fclose(fp_i);
////////////////////////////////////////////////////////////
	long Column_max = 0;
	long Row_max = 0;
	for(long i0 = 0 ; i0 < Line_max ; i0++){
		if(Row_max < Row_no[i0]) Row_max = Row_no[i0];
		if(Column_max < Column_no[i0]) Column_max = Column_no[i0];
	}	
	char buf[BUFSIZE];	// buffer for fgets
	if(sscanf(argv[1],"%s", buf) != 1){
//	if(sscanf(argv[1],"%[^.]", buf) != 1){
		fprintf(stderr,"scan error!: argv[1] = %s, buf = %s!\n", argv[1], buf);
		exit(1);
	}
	char eps_name[BUFSIZE];
	sprintf(eps_name,"%s_ResErr.eps",buf);
	FILE *fp_o;
	fp_o = fopen(eps_name,"w");
	if (fp_o == NULL){
		fprintf(stderr,"open error!: open output-file = %s\n", eps_name);
		exit(1);
	}
	long square_size = 2;
	fprintf(fp_o,"%%!PS-Adobe-3.0 EPSF-3.0\n%%%%BoundingBox: 0 0 %ld %ld\n", (Column_max+1)*square_size, (Row_max+1)*square_size);
	fprintf(fp_o,"%% Exe-file : %s (Updated on Jan 07, 2015)\n%% Min_scale = %g B, Max_scale = %g B\n", argv[0], scale_range[0], scale_range[1]);
	fprintf(fp_o,"gsave\n");
	for(long KR = 0 ; KR < Line_max ; KR++) {
		long x = Column_no[KR]*square_size;
		long y = ( Row_max - Row_no[KR] )*square_size;
		fprintf(fp_o,"\n%ld %ld moveto\n",  x, y);
		fprintf(fp_o,"%ld %ld lineto\n",  x, y+square_size);
		fprintf(fp_o,"%ld %ld lineto\n",  x+square_size, y+square_size);
		fprintf(fp_o,"%ld %ld lineto\n",  x+square_size, y);
		fprintf(fp_o,"closepath\n");
		double z = (log10(fabs(MatData[KR])+DBL_MIN) - scale_range[0])/(scale_range[1] - scale_range[0]);
		fprintf(fp_o,"%g %g %g setrgbcolor\n", function_gnuplot(z, func_para[0]), function_gnuplot(z, func_para[1]), function_gnuplot(z, func_para[2]));
		fprintf(fp_o,"fill\n");
	}
	free(Column_no);
	free(Row_no);
	free(MatData);
	
	fprintf(fp_o,"showpage\n");
	fclose(fp_o);
////////////////////////////////////////////////////////////
	sprintf(eps_name,"%s_Scale.eps",buf);
	fp_o = fopen(eps_name,"w");
	fprintf(fp_o,"%%!PS-Adobe-3.0 EPSF-3.0\n%%%%BoundingBox: %ld %ld %ld %ld\n", 
						square_size, square_size, 11*square_size, 101*square_size);//revised on Jan 07, 2015
	fprintf(fp_o,"%% Exe-file : %s (Updated on Jan 07, 2015)\n%% Min_scale = %g B, Max_scale = %g B\n", 
						argv[0], scale_range[0], scale_range[1]);
	for(long KR = 0 ; KR < 100 ; KR++) {
		long y = 99 - KR;
		long x = 0;
		fprintf(fp_o,"\n%ld %ld moveto\n",  x+square_size, (y+1)*square_size);
		fprintf(fp_o,"%ld %ld lineto\n",  x+square_size, (y+2)*square_size);
		fprintf(fp_o,"%ld %ld lineto\n",  x+11*square_size, (y+2)*square_size);
		fprintf(fp_o,"%ld %ld lineto\n",  x+11*square_size, (y+1)*square_size);
		fprintf(fp_o,"closepath\n");
		double z = (y + 0.5)*0.01;
		fprintf(fp_o,"%g %g %g setrgbcolor\n", 
				function_gnuplot(z, func_para[0]), function_gnuplot(z, func_para[1]), function_gnuplot(z, func_para[2]));
		fprintf(fp_o,"fill\n");
	}
/*	fprintf(fp_o,"\n%ld %ld moveto\n", square_size, square_size);
	fprintf(fp_o,"%ld %ld lineto\n", square_size, 101*square_size);
	fprintf(fp_o,"%ld %ld lineto\n", 11*square_size, 101*square_size);
	fprintf(fp_o,"%ld %ld lineto\n", 11*square_size, square_size);
	fprintf(fp_o,"closepath\n");
	fprintf(fp_o,"1 setlinewidth\n");
	fprintf(fp_o,"stroke\n");// comment out on Jan 07,2015 */
	fclose(fp_o);

	time_t timer_f = time(0);
	double t_span = difftime(timer_f,timer_s);
	fprintf(stderr,"# `MatrixOut', total exec. time= %g sec\n", t_span);
}
/*|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
||||||||||||                              input_file1, input_fileM                           ||||||||||||
||||||||||||                            Last updated on Jan 06, 2015                         ||||||||||||
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*/
long input_file1(FILE *fp_i)
{
	char buf[BUFSIZE];	// buffer for fgets
	long Line_max = 0;
	while(fgets(buf, sizeof( buf ), fp_i) != NULL){
//		fprintf(stderr,"line=%ld: %s", Line_max, buf);
		char comment_char[4];
		if(sscanf(buf, "%s", comment_char) != EOF){
			if (strncmp(comment_char, "#", 1) != 0 && strncmp(comment_char, "//", 2) != 0){
				long L[2];
				double D[4];
				if(sscanf(buf,"%ld %ld %lf %lf %lf %lf", &L[0], &L[1], &D[0], &D[1], &D[2], &D[3]) != EOF) Line_max += 1;
			}
		}
	}
	if(Line_max == 0){
		fprintf(stderr,"input error!: Line_max = 0\n");
		exit(1);
	}
	return(Line_max);
}
void input_fileM(FILE *fp_i, const long Mat_no, const long Line_max, long Column_no[Line_max], long Row_no[Line_max], double MatData[Line_max])
{
	char buf[BUFSIZE];	// buffer for fgets
	long Line_cont = 0;
	if(Mat_no > 4 || Mat_no < 1){
		fprintf(stderr,"Mat_no error!: Mat_no = %ld\n", Mat_no);
		exit(1);
	}
	while(fgets(buf, sizeof( buf ), fp_i) != NULL){
		char comment_char[4];
		if(sscanf(buf, "%s", comment_char) != EOF){
			if (strncmp(comment_char, "#", 1) != 0 && strncmp(comment_char, "//", 2) != 0){
				long L[2];
				double D[4];
				if(sscanf(buf,"%ld %ld %lf %lf %lf %lf", &L[0], &L[1], &D[0], &D[1], &D[2], &D[3]) != EOF){
					fprintf(stderr,"%ld, %ld, %g\n", L[0], L[1], D[Mat_no - 1]);
					Column_no[Line_cont] = L[0];
					Row_no[Line_cont] = L[1];
					MatData[Line_cont] = D[Mat_no - 1];
					Line_cont += 1;
					if(Line_cont == Line_max) goto Line_end;
				}
			}
		}
	}
	fprintf(stderr,"input error!: Line_cont = %ld\n", Line_cont);
	exit(1);
	Line_end:;
}
/*|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
||||||||||||                                    input_file3                                  ||||||||||||
||||||||||||                            Last updated on Nov 13, 2014                         ||||||||||||
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*/
void input_file3(FILE *fp_i3, long *data_c, double scale_range[2], long func_para[3])
{
	char buf[BUFSIZE];	// buffer for fgets

	while(fgets(buf, sizeof( buf ), fp_i3) != NULL) { 
		if(sscanf(buf,"%*[^=] %*[=] %ld", data_c) == 1) goto End_of_data_c;
	}
	fprintf(stderr,"No data_c is read @ input_file3!\n");
	exit(1);
	End_of_data_c:;
	
	if(*data_c < 1 || *data_c > 4) {
		fprintf(stderr,"mesh input error!: data_c = %ld\n", *data_c);
		exit(1);
	}

	while(fgets(buf, sizeof( buf ), fp_i3) != NULL) { 
		if(sscanf(buf,"%*[^=] %*[=] %lf %*[^=] %*[=] %lf", 
					&scale_range[0], &scale_range[1]) == 2) goto End_of_scale;
	}
	fprintf(stderr,"No scale_range is read @ input_file3!\n");
	exit(1);
	End_of_scale:;

	while(fgets(buf, sizeof( buf ), fp_i3) != NULL) { 
		if(sscanf(buf,"%*[^=] %*[=] %ld %*[^=] %*[=] %ld %*[^=] %*[=] %ld", 
					&func_para[0], &func_para[1], &func_para[2]) == 3) goto End_of_color;
	}
	fprintf(stderr,"No color-parameter is read @ input_file3!\n");
	exit(1);
	End_of_color:;
	// 3,3,3    ...gray (black-white)
	// 7,5,15   ...traditional pm3d (black-blue-red-yellow)
	// 3,11,6   ...green-red-violet
	// 23,28,3  ...ocean (green-blue-white);try also all other permutations
	// 21,22,23 ...hot (black-red-yellow-white)
	// 30,31,32 ...color printable on gray (black-blue-violet-yellow-white)
	// 33,13,10 ...rainbow (blue-green-yellow-red)
	// 34,35,36 ...AFM hot (black-red-yellow-white)
}

